# Awesome Python Books [![Awesome](https://cdn.rawgit.com/sindresorhus/awesome/d7305f38d29fed78fa85652e3a63e154dd8e8829/media/badge.svg)](https://github.com/sindresorhus/awesome)

> Directory of Python books

## 目录
- [语法](#语法)
- [数据结构与算法](#数据结构与算法)
- [游戏开发](#游戏开发)
- [硬件](#硬件)
- [机器学习](#机器学习)
- [自然语言处理](#自然语言处理)
- [网络](#网络)
- [科学与数据分析](#科学与数据分析)
- [安全](#安全)
- [SQL 和 ORMs](#SQL-和-ORMs)
- [系统管理](#系统管理)
- [测试](#测试)
- [WEB 开发](#WEB-开发)
- [WEB 数据抓取](#WEB-数据抓取)

## 语法
- 零基础
    - 《简明Python教程》[在线](http://wiki.jikexueyuan.com/project/simple-python-course/)
    - 《父与子的编程之旅：与小卡特一起学Python》[亚马逊](https://www.amazon.cn/dp/B00PG0MMLO) / [豆瓣](https://book.douban.com/subject/26005639/)
    - 《趣学Python编程》[亚马逊](https://www.amazon.cn/dp/B00IM56I5Q) / [豆瓣](https://book.douban.com/subject/25837145/)
    - 《"笨办法"学Python》[亚马逊](https://www.amazon.cn/dp/B00P6OJ0TC) / [在线](https://flyouting.gitbooks.io/learn-python-the-hard-way-cn/content/) / [豆瓣](https://book.douban.com/subject/26264642/)
    - 《Python编程初学者指南》[亚马逊](https://www.amazon.cn/dp/B00OZVSJAS/) / [豆瓣](https://book.douban.com/subject/26287445/)
    - 《编程导论》[亚马逊](https://www.amazon.cn/dp/B00W34DZ1M) / [豆瓣](https://book.douban.com/subject/26368668/)

- 入门
    - 《Python基础教程》[亚马逊](https://www.amazon.cn/dp/B00KAFX65Q) / [豆瓣](https://book.douban.com/subject/25880388/)
    - 《像计算机科学家一样思考Python》[亚马逊](https://www.amazon.cn/dp/B01ION3W54/) / [豆瓣](https://book.douban.com/subject/26870407/)
    - 《Python学习手册》[亚马逊](https://www.amazon.cn/dp/B004TUJ7A6) / [豆瓣](https://book.douban.com/subject/6049132/)
    - 《Python编程》[亚马逊](https://www.amazon.cn/dp/B00R3UI2NC) / [豆瓣](https://book.douban.com/subject/26314833/) 
    - 《Python核心编程》[亚马逊](https://www.amazon.cn/dp/B001BKVXOA/) / [豆瓣](https://book.douban.com/subject/3112503/)
    - 《Python编程：从入门到实践》[亚马逊](https://www.amazon.cn/dp/B01ION3VWI/) / [豆瓣](https://book.douban.com/subject/26829016/)

- 进阶
    - 《Python 3面向对象编程》[亚马逊](https://www.amazon.cn/dp/B010MG1S84) / [豆瓣](https://book.douban.com/subject/26468916/)
    - 《Python高手之路》[亚马逊](https://www.amazon.cn/dp/B00X65PEFC) / [豆瓣](https://book.douban.com/subject/26389274/)
    - 《Python编程实战：运用设计模式、并发和程序库创建高质量程序》[亚马逊](https://www.amazon.cn/dp/B00MHDPIJ6) / [豆瓣](https://book.douban.com/subject/25955274/)
    - 《Python高级编程》[亚马逊](https://book.douban.com/subject/4212921/) / [豆瓣](https://book.douban.com/subject/27133480/)
    - 《Python应用核心编程》[豆瓣](https://book.douban.com/subject/26801374/)
    - 《Python进阶》[在线](https://eastlakeside.gitbooks.io/interpy-zh/content/)
    - 《Effective Python：编写高质量Python代码的59个有效方法》[亚马逊](https://www.amazon.cn/dp/B01ASI36QS) / [豆瓣](https://book.douban.com/subject/26709315/)
    - 《流畅的Python》[亚马逊](https://www.amazon.cn/dp/B072HMKKPG) / [豆瓣](https://book.douban.com/subject/27028517/)
    - 《Python设计模式》[亚马逊](https://www.amazon.cn/dp/B073MDN9KZ) / [豆瓣](https://book.douban.com/subject/27091288/)
    - 《精通 Python 设计模式》[亚马逊](https://www.amazon.cn/dp/B01ION3VW8) / [豆瓣](https://book.douban.com/subject/26829015/)

- 高阶
    - 《Python性能分析与优化》[亚马逊](https://www.amazon.cn/dp/B01HB0KNCG) / [豆瓣](https://book.douban.com/subject/26819420/)
    - 《高性能Python》[亚马逊](https://www.amazon.cn/dp/B072RBY4M5) / [豆瓣](https://book.douban.com/subject/27064848/)
    - 《Cython - A Guide for Python Programmers》[豆瓣](https://book.douban.com/subject/26250831/)
    - 《Python源码剖析》[豆瓣](https://book.douban.com/subject/3117898/)

- 参考
    - 《Python标准库》[亚马逊](https://book.douban.com/subject/10773324/) / [豆瓣](https://book.douban.com/subject/10773324/)
    - 《Python Cookbook》[亚马逊](https://www.amazon.cn/dp/B00WKR1OKG) / [豆瓣](https://book.douban.com/subject/26381341/)
    - 《Python参考手册》[亚马逊](https://book.douban.com/subject/5401851/) / [豆瓣](https://book.douban.com/subject/5401851/)
    - 《Python in a Nutshell》[豆瓣](https://book.douban.com/subject/1845309/)

## 数据结构与算法
- 《数据结构与算法：Python语言实现》[豆瓣](https://book.douban.com/subject/10607365/)
- 《Problem Solving with Algorithms and Data Structures Using Python》[豆瓣](https://book.douban.com/subject/21325184/)
- 《Python算法教程》[亚马逊](https://www.amazon.cn/dp/B019NB0VCI) / [豆瓣](https://book.douban.com/subject/26699412/)

## 游戏开发
- 《Python和Pygame游戏开发指南》[亚马逊](https://www.amazon.cn/dp/B019IZ6ZWO) / [豆瓣](https://book.douban.com/subject/26702574/)

## 硬件
- 《真实世界的Python仪器监控》[豆瓣](https://book.douban.com/subject/20773481/)

## 机器学习
- 《机器学习系统设计》[亚马逊](https://www.amazon.cn/dp/B00KYXKIDM) / [豆瓣](https://book.douban.com/subject/25899625/)
- 《机器学习实战》[亚马逊](https://www.amazon.cn/dp/B00D747PTK) / [豆瓣](https://book.douban.com/subject/24703171/)
- 《集体智慧编程》[亚马逊](https://www.amazon.cn/dp/B00UI93JD8) / [豆瓣](https://book.douban.com/subject/3288908/)

## 自然语言处理
- 《Mastering Python Regular Expressions》[豆瓣](https://book.douban.com/subject/25910720/)
- 《Python自然语言处理》[亚马逊](https://www.amazon.cn/dp/B00L7IV7C4) / [豆瓣](https://book.douban.com/subject/5336893/)

## 网络编程
- 《Python网络编程》[亚马逊](https://www.amazon.cn/dp/B01LXK2W32) / [豆瓣](https://book.douban.com/subject/26869212/)

## 科学与数据分析
- 《数据科学入门》[亚马逊](https://www.amazon.cn/dp/B01DLBQPQC) / [豆瓣](https://book.douban.com/subject/26741078/)
- 《利用Python进行数据分析》[亚马逊](https://www.amazon.cn/dp/B00GHGZLWS) / [豆瓣](https://book.douban.com/subject/25779298/)
- 《SciPy and NumPy: An Overview for Developers》[豆瓣](https://book.douban.com/subject/10561724/)
- 《Python数据分析基础教程：NumPy学习指南》[亚马逊](https://www.amazon.cn/dp/B00HLA8U86) / [豆瓣](https://book.douban.com/subject/25798462/)
- 《Python金融大数据分析》[亚马逊](https://www.amazon.cn/dp/B0182K8YMA) / [豆瓣](https://book.douban.com/subject/26670241/)
- 《面向程序员的数据挖掘指南》[亚马逊](https://www.amazon.cn/dp/B017QWR6BU) / [在线](http://dataminingguide.books.yourtion.com) / [豆瓣](https://book.douban.com/subject/26652166)

## 安全
- 《Python黑帽子：黑客与渗透测试编程之道》[亚马逊](https://www.amazon.cn/dp/B013KKCLE4) / [豆瓣](https://book.douban.com/subject/26590145/)
- 《Python灰帽子：黑客与逆向工程师的Python编程之道》[豆瓣](https://book.douban.com/subject/6025284/)
- 《Python绝技：运用Python成为顶级黑客》[亚马逊](https://www.amazon.cn/dp/B019ZRGBVU) / [豆瓣](https://book.douban.com/subject/26702570/)

## SQL 和 ORMs
- 《SQLAlchemy：Python数据库实战》[亚马逊](https://www.amazon.cn/dp/B07YF84WV3) / [豆瓣](https://book.douban.com/subject/34784326/)

## 系统管理
- 《Python UNIX 和 Linux 系统管理指南》[亚马逊](https://book.douban.com/subject/4031965/) / [豆瓣](https://book.douban.com/subject/4031965/)

## 测试
- 《Testing Python: Applying Unit Testing, TDD, BDD and Acceptance Testing》[豆瓣](https://book.douban.com/subject/25953479/)

## WEB 开发
- 《Flask Web开发：基于Python的Web应用开发实战》[豆瓣](https://book.douban.com/subject/26274202/)
- 《深入理解 Flask》[亚马逊](https://www.amazon.cn/dp/B01IA9I2I4) / [豆瓣](https://book.douban.com/subject/26838547/)
- 《Introduction to Tornado》[豆瓣](https://book.douban.com/subject/7906788/)
- 《The Definitive Guide to Django》[豆瓣](https://book.douban.com/subject/3617254/)
- 《Test-Driven Development with Django》[豆瓣](https://book.douban.com/subject/26608104/)
- 《Python Web开发：测试驱动方法》[亚马逊](https://www.amazon.cn/dp/B016I9T8SQ) / [豆瓣](https://book.douban.com/subject/26640135/)

## WEB 数据抓取
- 《Python网络数据采集》[亚马逊](https://www.amazon.cn/dp/B01DU8CXJ4) / [豆瓣](https://book.douban.com/subject/26740503/)

## Other Awesome Lists
- [awesome-python](https://github.com/vinta/awesome-python)
- [awesome-flask](https://github.com/humiaozuzu/awesome-flask)
